diff --git a/gcc/cp/constraint.cc b/gcc/cp/constraint.cc
index 722fc334e6f..567dd35fe0a 100644
--- a/gcc/cp/constraint.cc
+++ b/gcc/cp/constraint.cc
@@ -3723,6 +3723,9 @@ diagnose_trait_expr (tree expr, tree args)
     case CPTK_IS_CLASS:
       inform (loc, "  %qT is not a class", t1);
       break;
+    case CPTK_IS_CONST:
+      inform (loc, "  %qT is not a const type", t1);
+      break;
     case CPTK_IS_CONSTRUCTIBLE:
       if (!t2)
     inform (loc, "  %qT is not default constructible", t1);
diff --git a/gcc/cp/cp-trait.def b/gcc/cp/cp-trait.def
index 0e48e64b8dd..9e4e6d798a0 100644
--- a/gcc/cp/cp-trait.def
+++ b/gcc/cp/cp-trait.def
@@ -62,6 +62,7 @@ DEFTRAIT_EXPR (IS_AGGREGATE, "__is_aggregate", 1)
 DEFTRAIT_EXPR (IS_ASSIGNABLE, "__is_assignable", 2)
 DEFTRAIT_EXPR (IS_BASE_OF, "__is_base_of", 2)
 DEFTRAIT_EXPR (IS_CLASS, "__is_class", 1)
+DEFTRAIT_EXPR (IS_CONST, "__is_const", 1)
 DEFTRAIT_EXPR (IS_CONSTRUCTIBLE, "__is_constructible", -1)
 DEFTRAIT_EXPR (IS_CONVERTIBLE, "__is_convertible", 2)
 DEFTRAIT_EXPR (IS_EMPTY, "__is_empty", 1)
diff --git a/gcc/cp/cp-trait.gperf b/gcc/cp/cp-trait.gperf
index c3feb78d3c4..ad720832ccb 100644
--- a/gcc/cp/cp-trait.gperf
+++ b/gcc/cp/cp-trait.gperf
@@ -43,6 +43,7 @@ struct cp_trait {
 "__is_assignable", CPTK_IS_ASSIGNABLE, true, false, false
 "__is_base_of", CPTK_IS_BASE_OF, true, false, false
 "__is_class", CPTK_IS_CLASS, false, false, false
+"__is_const", CPTK_IS_CONST, false, false, false
 "__is_constructible", CPTK_IS_CONSTRUCTIBLE, false, true, false
 "__is_convertible", CPTK_IS_CONVERTIBLE, true, false, false
 "__is_empty", CPTK_IS_EMPTY, false, false, false
diff --git a/gcc/cp/cp-trait.h b/gcc/cp/cp-trait.h
index db9476a8ac1..4a2100779cf 100644
--- a/gcc/cp/cp-trait.h
+++ b/gcc/cp/cp-trait.h
@@ -1,6 +1,6 @@
 /* C++ code produced by gperf version 3.1 */
 /* Command-line: gperf -o -C -E -D -N find -L C++ --output-file ../../gcc/cp/cp-trait.h ../../gcc/cp/cp-trait.gperf  */
-/* Computed positions: -k'8' */
+/* Computed positions: -k'6,8' */
 
 #if !((' ' == 32) && ('!' == 33) && ('"' == 34) && ('#' == 35) \
       && ('%' == 37) && ('&' == 38) && ('\'' == 39) && ('(' == 40) \
@@ -56,7 +56,7 @@ struct cp_trait {
   bool variadic;
   bool type;
 };
-/* maximum key range = 79, duplicates = 0 */
+/* maximum key range = 89, duplicates = 0 */
 
 class cp_trait_lookup
 {
@@ -71,32 +71,32 @@ cp_trait_lookup::hash (const char *str, size_t len)
 {
   static const unsigned char asso_values[] =
     {
-      86, 86, 86, 86, 86, 86, 86, 86, 86, 86,
-      86, 86, 86, 86, 86, 86, 86, 86, 86, 86,
-      86, 86, 86, 86, 86, 86, 86, 86, 86, 86,
-      86, 86, 86, 86, 86, 86, 86, 86, 86, 86,
-      86, 86, 86, 86, 86, 86, 86, 86, 86, 86,
-      86, 86, 86, 86, 86, 86, 86, 86, 86, 86,
-      86, 86, 86, 86, 86, 86, 86, 86, 86, 86,
-      86, 86, 86, 86, 86, 86, 86, 86, 86, 86,
-      86, 86, 86, 86, 86, 86, 86, 86, 86, 86,
-      86, 86, 86, 86, 86, 86, 86,  1, 86, 86,
-       0, 35, 86,  0, 86,  0, 86, 86, 10, 10,
-      50, 15, 55, 86, 30,  5, 15,  0, 86, 86,
-      86, 20, 86, 86, 86, 86, 86, 86, 86, 86,
-      86, 86, 86, 86, 86, 86, 86, 86, 86, 86,
-      86, 86, 86, 86, 86, 86, 86, 86, 86, 86,
-      86, 86, 86, 86, 86, 86, 86, 86, 86, 86,
-      86, 86, 86, 86, 86, 86, 86, 86, 86, 86,
-      86, 86, 86, 86, 86, 86, 86, 86, 86, 86,
-      86, 86, 86, 86, 86, 86, 86, 86, 86, 86,
-      86, 86, 86, 86, 86, 86, 86, 86, 86, 86,
-      86, 86, 86, 86, 86, 86, 86, 86, 86, 86,
-      86, 86, 86, 86, 86, 86, 86, 86, 86, 86,
-      86, 86, 86, 86, 86, 86, 86, 86, 86, 86,
-      86, 86, 86, 86, 86, 86, 86, 86, 86, 86,
-      86, 86, 86, 86, 86, 86, 86, 86, 86, 86,
-      86, 86, 86, 86, 86, 86
+      96, 96, 96, 96, 96, 96, 96, 96, 96, 96,
+      96, 96, 96, 96, 96, 96, 96, 96, 96, 96,
+      96, 96, 96, 96, 96, 96, 96, 96, 96, 96,
+      96, 96, 96, 96, 96, 96, 96, 96, 96, 96,
+      96, 96, 96, 96, 96, 96, 96, 96, 96, 96,
+      96, 96, 96, 96, 96, 96, 96, 96, 96, 96,
+      96, 96, 96, 96, 96, 96, 96, 96, 96, 96,
+      96, 96, 96, 96, 96, 96, 96, 96, 96, 96,
+      96, 96, 96, 96, 96, 96, 96, 96, 96, 96,
+      96, 96, 96, 96, 96, 20, 96, 35, 10, 20,
+      40,  0, 30, 15, 96,  0, 96, 96,  5, 15,
+      30,  0,  5, 96, 10, 25,  5,  0, 96, 96,
+      96,  5, 96, 96, 96, 96, 96, 96, 96, 96,
+      96, 96, 96, 96, 96, 96, 96, 96, 96, 96,
+      96, 96, 96, 96, 96, 96, 96, 96, 96, 96,
+      96, 96, 96, 96, 96, 96, 96, 96, 96, 96,
+      96, 96, 96, 96, 96, 96, 96, 96, 96, 96,
+      96, 96, 96, 96, 96, 96, 96, 96, 96, 96,
+      96, 96, 96, 96, 96, 96, 96, 96, 96, 96,
+      96, 96, 96, 96, 96, 96, 96, 96, 96, 96,
+      96, 96, 96, 96, 96, 96, 96, 96, 96, 96,
+      96, 96, 96, 96, 96, 96, 96, 96, 96, 96,
+      96, 96, 96, 96, 96, 96, 96, 96, 96, 96,
+      96, 96, 96, 96, 96, 96, 96, 96, 96, 96,
+      96, 96, 96, 96, 96, 96, 96, 96, 96, 96,
+      96, 96, 96, 96, 96, 96
     };
   unsigned int hval = len;
 
@@ -106,6 +106,8 @@ cp_trait_lookup::hash (const char *str, size_t len)
         hval += asso_values[static_cast<unsigned char>(str[7])];
       /*FALLTHROUGH*/
       case 7:
+      case 6:
+        hval += asso_values[static_cast<unsigned char>(str[5])];
         break;
     }
   return hval;
@@ -116,116 +118,118 @@ cp_trait_lookup::find (const char *str, size_t len)
 {
   enum
     {
-      TOTAL_KEYWORDS = 45,
+      TOTAL_KEYWORDS = 46,
       MIN_WORD_LENGTH = 7,
       MAX_WORD_LENGTH = 37,
       MIN_HASH_VALUE = 7,
-      MAX_HASH_VALUE = 85
+      MAX_HASH_VALUE = 95
     };
 
   static const struct cp_trait wordlist[] =
     {
-#line 74 "../../gcc/cp/cp-trait.gperf"
+#line 75 "../../gcc/cp/cp-trait.gperf"
       {"__bases", CPTK_BASES, false, false, true},
-#line 57 "../../gcc/cp/cp-trait.gperf"
-      {"__is_pod", CPTK_IS_POD, false, false, false},
-#line 49 "../../gcc/cp/cp-trait.gperf"
+#line 50 "../../gcc/cp/cp-trait.gperf"
       {"__is_enum", CPTK_IS_ENUM, false, false, false},
-#line 65 "../../gcc/cp/cp-trait.gperf"
+#line 66 "../../gcc/cp/cp-trait.gperf"
       {"__is_union", CPTK_IS_UNION, false, false, false},
-#line 45 "../../gcc/cp/cp-trait.gperf"
-      {"__is_class", CPTK_IS_CLASS, false, false, false},
-#line 61 "../../gcc/cp/cp-trait.gperf"
+#line 69 "../../gcc/cp/cp-trait.gperf"
+      {"__remove_cv", CPTK_REMOVE_CV, false, false, true},
+#line 70 "../../gcc/cp/cp-trait.gperf"
+      {"__remove_cvref", CPTK_REMOVE_CVREF, false, false, true},
+#line 49 "../../gcc/cp/cp-trait.gperf"
+      {"__is_empty", CPTK_IS_EMPTY, false, false, false},
+#line 62 "../../gcc/cp/cp-trait.gperf"
       {"__is_trivial", CPTK_IS_TRIVIAL, false, false, false},
-#line 42 "../../gcc/cp/cp-trait.gperf"
-      {"__is_aggregate", CPTK_IS_AGGREGATE, false, false, false},
+#line 71 "../../gcc/cp/cp-trait.gperf"
+      {"__remove_reference", CPTK_REMOVE_REFERENCE, false, false, true},
+#line 76 "../../gcc/cp/cp-trait.gperf"
+      {"__direct_bases", CPTK_DIRECT_BASES, false, false, true},
 #line 73 "../../gcc/cp/cp-trait.gperf"
-      {"__is_deducible ", CPTK_IS_DEDUCIBLE, true, false, false},
-#line 44 "../../gcc/cp/cp-trait.gperf"
-      {"__is_base_of", CPTK_IS_BASE_OF, true, false, false},
-#line 41 "../../gcc/cp/cp-trait.gperf"
-      {"__is_abstract", CPTK_IS_ABSTRACT, false, false, false},
+      {"__underlying_type", CPTK_UNDERLYING_TYPE, false, false, true},
+#line 72 "../../gcc/cp/cp-trait.gperf"
+      {"__type_pack_element", CPTK_TYPE_PACK_ELEMENT, false, true, true},
 #line 59 "../../gcc/cp/cp-trait.gperf"
-      {"__is_same", CPTK_IS_SAME, true, false, false},
-#line 43 "../../gcc/cp/cp-trait.gperf"
-      {"__is_assignable", CPTK_IS_ASSIGNABLE, true, false, false},
-#line 60 "../../gcc/cp/cp-trait.gperf"
-      {"__is_standard_layout", CPTK_IS_STD_LAYOUT, false, false, false},
-#line 31 "../../gcc/cp/cp-trait.gperf"
-      {"__is_same_as", CPTK_IS_SAME, true, false, false},
-#line 64 "../../gcc/cp/cp-trait.gperf"
-      {"__is_trivially_copyable", CPTK_IS_TRIVIALLY_COPYABLE, false, false, false},
-#line 40 "../../gcc/cp/cp-trait.gperf"
-      {"__has_virtual_destructor", CPTK_HAS_VIRTUAL_DESTRUCTOR, false, false, false},
-#line 62 "../../gcc/cp/cp-trait.gperf"
-      {"__is_trivially_assignable", CPTK_IS_TRIVIALLY_ASSIGNABLE, true, false, false},
-#line 58 "../../gcc/cp/cp-trait.gperf"
       {"__is_polymorphic", CPTK_IS_POLYMORPHIC, false, false, false},
-#line 72 "../../gcc/cp/cp-trait.gperf"
-      {"__underlying_type", CPTK_UNDERLYING_TYPE, false, false, true},
+#line 53 "../../gcc/cp/cp-trait.gperf"
+      {"__is_literal_type", CPTK_IS_LITERAL_TYPE, false, false, false},
+#line 65 "../../gcc/cp/cp-trait.gperf"
+      {"__is_trivially_copyable", CPTK_IS_TRIVIALLY_COPYABLE, false, false, false},
 #line 63 "../../gcc/cp/cp-trait.gperf"
-      {"__is_trivially_constructible", CPTK_IS_TRIVIALLY_CONSTRUCTIBLE, false, true, false},
-#line 75 "../../gcc/cp/cp-trait.gperf"
-      {"__direct_bases", CPTK_DIRECT_BASES, false, false, true},
+      {"__is_trivially_assignable", CPTK_IS_TRIVIALLY_ASSIGNABLE, true, false, false},
 #line 52 "../../gcc/cp/cp-trait.gperf"
-      {"__is_literal_type", CPTK_IS_LITERAL_TYPE, false, false, false},
+      {"__is_layout_compatible", CPTK_IS_LAYOUT_COMPATIBLE, true, false, false},
+#line 64 "../../gcc/cp/cp-trait.gperf"
+      {"__is_trivially_constructible", CPTK_IS_TRIVIALLY_CONSTRUCTIBLE, false, true, false},
+#line 68 "../../gcc/cp/cp-trait.gperf"
+      {"__reference_converts_from_temporary", CPTK_REF_CONVERTS_FROM_TEMPORARY, true, false, false},
+#line 67 "../../gcc/cp/cp-trait.gperf"
+      {"__reference_constructs_from_temporary", CPTK_REF_CONSTRUCTS_FROM_TEMPORARY, true, false, false},
 #line 34 "../../gcc/cp/cp-trait.gperf"
       {"__has_nothrow_copy", CPTK_HAS_NOTHROW_COPY, false, false, false},
 #line 32 "../../gcc/cp/cp-trait.gperf"
       {"__has_nothrow_assign", CPTK_HAS_NOTHROW_ASSIGN, false, false, false},
-#line 56 "../../gcc/cp/cp-trait.gperf"
+#line 57 "../../gcc/cp/cp-trait.gperf"
       {"__is_pointer_interconvertible_base_of", CPTK_IS_POINTER_INTERCONVERTIBLE_BASE_OF, true, false, false},
-#line 53 "../../gcc/cp/cp-trait.gperf"
-      {"__is_nothrow_assignable", CPTK_IS_NOTHROW_ASSIGNABLE, true, false, false},
-#line 55 "../../gcc/cp/cp-trait.gperf"
-      {"__is_nothrow_convertible", CPTK_IS_NOTHROW_CONVERTIBLE, true, false, false},
+#line 40 "../../gcc/cp/cp-trait.gperf"
+      {"__has_virtual_destructor", CPTK_HAS_VIRTUAL_DESTRUCTOR, false, false, false},
 #line 33 "../../gcc/cp/cp-trait.gperf"
       {"__has_nothrow_constructor", CPTK_HAS_NOTHROW_CONSTRUCTOR, false, false, false},
-#line 54 "../../gcc/cp/cp-trait.gperf"
-      {"__is_nothrow_constructible", CPTK_IS_NOTHROW_CONSTRUCTIBLE, false, true, false},
-#line 51 "../../gcc/cp/cp-trait.gperf"
-      {"__is_layout_compatible", CPTK_IS_LAYOUT_COMPATIBLE, true, false, false},
-#line 68 "../../gcc/cp/cp-trait.gperf"
-      {"__remove_cv", CPTK_REMOVE_CV, false, false, true},
+#line 44 "../../gcc/cp/cp-trait.gperf"
+      {"__is_base_of", CPTK_IS_BASE_OF, true, false, false},
 #line 37 "../../gcc/cp/cp-trait.gperf"
       {"__has_trivial_copy", CPTK_HAS_TRIVIAL_COPY, false, false, false},
-#line 69 "../../gcc/cp/cp-trait.gperf"
-      {"__remove_cvref", CPTK_REMOVE_CVREF, false, false, true},
+#line 60 "../../gcc/cp/cp-trait.gperf"
+      {"__is_same", CPTK_IS_SAME, true, false, false},
 #line 35 "../../gcc/cp/cp-trait.gperf"
       {"__has_trivial_assign", CPTK_HAS_TRIVIAL_ASSIGN, false, false, false},
-#line 70 "../../gcc/cp/cp-trait.gperf"
-      {"__remove_reference", CPTK_REMOVE_REFERENCE, false, false, true},
+#line 31 "../../gcc/cp/cp-trait.gperf"
+      {"__is_same_as", CPTK_IS_SAME, true, false, false},
+#line 58 "../../gcc/cp/cp-trait.gperf"
+      {"__is_pod", CPTK_IS_POD, false, false, false},
 #line 38 "../../gcc/cp/cp-trait.gperf"
       {"__has_trivial_destructor", CPTK_HAS_TRIVIAL_DESTRUCTOR, false, false, false},
 #line 36 "../../gcc/cp/cp-trait.gperf"
       {"__has_trivial_constructor", CPTK_HAS_TRIVIAL_CONSTRUCTOR, false, false, false},
-#line 50 "../../gcc/cp/cp-trait.gperf"
-      {"__is_final", CPTK_IS_FINAL, false, false, false},
+#line 54 "../../gcc/cp/cp-trait.gperf"
+      {"__is_nothrow_assignable", CPTK_IS_NOTHROW_ASSIGNABLE, true, false, false},
+#line 56 "../../gcc/cp/cp-trait.gperf"
+      {"__is_nothrow_convertible", CPTK_IS_NOTHROW_CONVERTIBLE, true, false, false},
+#line 46 "../../gcc/cp/cp-trait.gperf"
+      {"__is_const", CPTK_IS_CONST, false, false, false},
+#line 55 "../../gcc/cp/cp-trait.gperf"
+      {"__is_nothrow_constructible", CPTK_IS_NOTHROW_CONSTRUCTIBLE, false, true, false},
+#line 42 "../../gcc/cp/cp-trait.gperf"
+      {"__is_aggregate", CPTK_IS_AGGREGATE, false, false, false},
+#line 45 "../../gcc/cp/cp-trait.gperf"
+      {"__is_class", CPTK_IS_CLASS, false, false, false},
 #line 48 "../../gcc/cp/cp-trait.gperf"
-      {"__is_empty", CPTK_IS_EMPTY, false, false, false},
-#line 47 "../../gcc/cp/cp-trait.gperf"
       {"__is_convertible", CPTK_IS_CONVERTIBLE, true, false, false},
-#line 46 "../../gcc/cp/cp-trait.gperf"
+#line 47 "../../gcc/cp/cp-trait.gperf"
       {"__is_constructible", CPTK_IS_CONSTRUCTIBLE, false, true, false},
-#line 67 "../../gcc/cp/cp-trait.gperf"
-      {"__reference_converts_from_temporary", CPTK_REF_CONVERTS_FROM_TEMPORARY, true, false, false},
-#line 66 "../../gcc/cp/cp-trait.gperf"
-      {"__reference_constructs_from_temporary", CPTK_REF_CONSTRUCTS_FROM_TEMPORARY, true, false, false},
-#line 71 "../../gcc/cp/cp-trait.gperf"
-      {"__type_pack_element", CPTK_TYPE_PACK_ELEMENT, false, true, true},
+#line 51 "../../gcc/cp/cp-trait.gperf"
+      {"__is_final", CPTK_IS_FINAL, false, false, false},
+#line 41 "../../gcc/cp/cp-trait.gperf"
+      {"__is_abstract", CPTK_IS_ABSTRACT, false, false, false},
+#line 43 "../../gcc/cp/cp-trait.gperf"
+      {"__is_assignable", CPTK_IS_ASSIGNABLE, true, false, false},
+#line 61 "../../gcc/cp/cp-trait.gperf"
+      {"__is_standard_layout", CPTK_IS_STD_LAYOUT, false, false, false},
 #line 39 "../../gcc/cp/cp-trait.gperf"
-      {"__has_unique_object_representations", CPTK_HAS_UNIQUE_OBJ_REPRESENTATIONS, false, false, false}
+      {"__has_unique_object_representations", CPTK_HAS_UNIQUE_OBJ_REPRESENTATIONS, false, false, false},
+#line 74 "../../gcc/cp/cp-trait.gperf"
+      {"__is_deducible ", CPTK_IS_DEDUCIBLE, true, false, false}
     };
 
   static const signed char lookup[] =
     {
-      -1, -1, -1, -1, -1, -1, -1,  0,  1,  2,  3,  4,  5, -1,
-       6,  7, -1,  8,  9, 10, 11, 12, 13, 14, 15, 16, 17, 18,
-      19, 20, -1, -1, 21, 22, -1, 23, -1, 24, 25, 26, 27, 28,
-      29, -1, -1, -1, 30, -1, 31, 32, 33, -1, -1, 34, 35, 36,
-      -1, -1, -1, -1, 37, -1, -1, -1, -1, 38, 39, -1, 40, -1,
-      41, -1, 42, -1, 43, -1, -1, -1, -1, -1, -1, -1, -1, -1,
-      -1, 44
+      -1, -1, -1, -1, -1, -1, -1,  0, -1,  1,  2,  3, -1, -1,
+       4,  5, -1,  6,  7,  8, -1, -1,  9, -1, 10, -1, 11, 12,
+      13, -1, 14, -1, 15, 16, -1, 17, -1, 18, 19, -1, 20, -1,
+      21, -1, 22, 23, -1, 24, 25, 26, 27, -1, 28, 29, 30, 31,
+      -1, -1, 32, 33, 34, 35, -1, -1, 36, 37, 38, -1, 39, -1,
+      40, -1, -1, 41, -1, 42, -1, -1, -1, -1, 43, -1, -1, -1,
+      -1, 44, -1, -1, -1, -1, -1, -1, -1, -1, -1, 45
     };
 
   if (len <= MAX_WORD_LENGTH && len >= MIN_WORD_LENGTH)
diff --git a/gcc/cp/semantics.cc b/gcc/cp/semantics.cc
index 782aa515da0..23f1d1c249a 100644
--- a/gcc/cp/semantics.cc
+++ b/gcc/cp/semantics.cc
@@ -12154,6 +12154,9 @@ trait_expr_value (cp_trait_kind kind, tree type1, tree type2)
     case CPTK_IS_CLASS:
       return NON_UNION_CLASS_TYPE_P (type1);
 
+    case CPTK_IS_CONST:
+      return CP_TYPE_CONST_P (type1);
+
     case CPTK_IS_CONSTRUCTIBLE:
       return is_xible (INIT_EXPR, type1, type2);
 
@@ -12371,6 +12374,7 @@ finish_trait_expr (location_t loc, cp_trait_kind kind, tree type1, tree type2)
       break;
 
     case CPTK_IS_CLASS:
+    case CPTK_IS_CONST:
     case CPTK_IS_ENUM:
     case CPTK_IS_SAME:
     case CPTK_IS_UNION:
diff --git a/gcc/testsuite/g++.dg/ext/has-builtin-1.C b/gcc/testsuite/g++.dg/ext/has-builtin-1.C
index 2223f08a628..e6e481b13c5 100644
--- a/gcc/testsuite/g++.dg/ext/has-builtin-1.C
+++ b/gcc/testsuite/g++.dg/ext/has-builtin-1.C
@@ -65,6 +65,9 @@
 #if !__has_builtin (__is_class)
 # error "__has_builtin (__is_class) failed"
 #endif
+#if !__has_builtin (__is_const)
+# error "__has_builtin (__is_const) failed"
+#endif
 #if !__has_builtin (__is_constructible)
 # error "__has_builtin (__is_constructible) failed"
 #endif
diff --git a/gcc/testsuite/g++.dg/ext/is_const.C b/gcc/testsuite/g++.dg/ext/is_const.C
new file mode 100644
index 00000000000..8f2d7c2fce9
--- /dev/null
+++ b/gcc/testsuite/g++.dg/ext/is_const.C
@@ -0,0 +1,19 @@
+// { dg-do compile { target c++11 } }
+
+#include <testsuite_tr1.h>
+
+using namespace __gnu_test;
+
+#define SA(X) static_assert((X),#X)
+
+// Positive tests.
+SA(__is_const(const int));
+SA(__is_const(const volatile int));
+SA(__is_const(cClassType));
+SA(__is_const(cvClassType));
+
+// Negative tests.
+SA(!__is_const(int));
+SA(!__is_const(volatile int));
+SA(!__is_const(ClassType));
+SA(!__is_const(vClassType));